/* ---------------------------------------------------------------------------
**	generic MGA fixed clocks
** ---------------------------------------------------------------------------
**
**	Copyright (c)	1995-1997	Steffen Seeger
**
**	This program is free software; you can redistribute it and/or modify
**	it under the terms of the GNU General Public License as published by
**	the Free Software Foundation; version 2, or any later version.
**
**	You should have received a copy of the GNU General Public License
**	along with this program; see the file COPYING.  If not, write to
**	the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
** ---------------------------------------------------------------------------
**
**	$Log: hgc.c,v $
**	Revision 1.3  1997/11/08 15:12:41  becka
**	Namespace cleanup ... probably broke all and everything ...
**	
**	Revision 1.2  1997/10/03 11:25:05  seeger
**	minor:	added CVS logging, maintainer definition and standard headers.
**	
*/

#include <ggi/maintainers.h>
#define	MAINTAINER	Steffen_Seeger
#define	DRIVER_NAME	"MGA clock chip driver"
#define	DRIVER_REV	"$Revision: 1.3 $"

#include <ggi/module.h>

struct kgi_clock clock =
{
	"generic",		/* manufacturer		*/
	"MDA",			/* model		*/
	GM_ALL,			/* supported modes	*/
	0,			/* special capabilities	*/
	{ 0x7FFF, 0x7FFF },	/* maximum resolution	*/


	CLK_TYPE_FIXED,		/* fixed clock values	*/

	/*	The clock values. Note that they have to be in descending
	**	order and that there must be no repetitions.
	*/

	{{  16257000,        0,         0,         0,
	          0,         0,         0,         0,
	          0,         0,         0,         0,
	          0,         0,         0,         0
	}}
};

/*
**	Driving CS[0:3] to clkindex[i] selects clock.clock.freq[i].
*/

static unsigned char clkindex[MAX_FIXED_CLOCKS] =
{	0x00, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF,
	0xFF, 0xFF, 0xFF, 0xFF
};

static inline struct kgi_clock *init_clock(void)
{
	/*	no detection, the chipset driver does it.
	*/
	return &clock;
}

static inline void done_clock(void)
{
}

#include "fixed.inc"
