/* 
 *  Graphics library for GGI. Mode management.
 *
 *  Copyright (C) 1997 Andreas Beck - becka@sunserver1.rz.uni-duesseldorf.de
 *
 *  If you do any modifications, I would like you to send diffs to me
 *  to allow for collecting a more and more complete set of drivers and
 *  to improve existing ones.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free
 *  Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * ---------------------------------------------------------------------
 *	
 *	$Log: db.c,v $
 *	Revision 1.2  1997/11/15 01:13:16  willie
 *	Changed GPL to LGPL License
 *	
 *	Revision 1.1  1997/10/26 23:46:22  becka
 *	Restructured default visuals.
 *	Added some X keysyms
 *	Added some cards
 *	
 *
 * ---------------------------------------------------------------------
 */

#include "internal.h"
#include <ggi/libggi_db.h>

#undef putc

/************** DirectBuffer calls ****************/

int  ggiDBGetBuffer(ggi_visual *vis, ggi_directbuffer_t *buf)
{
	ggi_directbuffer *curbuf=vis->info.db;

	if (*buf==NULL) {
  		*buf=curbuf;
  		return 0;
  	}

  	while(curbuf)
  	{
		if (*buf==curbuf) {
			*buf=curbuf->next;
			return 0;
		}
		curbuf=curbuf->next;
  	}

	*buf=NULL;	/* Be kind even to simple-minded buggy apps. */
	return -EINVAL;
}

enum ggi_buffer_layout ggiDBGetLayout(ggi_directbuffer_t buf)
{
	return buf->layout;
}

ggi_pixellinearbuffer *ggiDBGetPLB(ggi_directbuffer_t buf)
{
	return &(buf->buffer.pixellinearbuffer);
}
