/* 
   Graphics library for GGI.

   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de
   Copyright (C) 1997 Jason McMullan - jmcc@cs.cmu.edu

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "ggi-dl.h"

#include "font/8x8"

/**********TEMPORARY************/
/* Blit out a 2-color bitfield */
/*******************************/
static int GGIblit2c(ggi_visual *vis,int x,int y,
				      int xwidth,int ywidth,void *field)
{
	int xp,bp;
	int color;

	for(;ywidth--;y++) {
		for(xp=0,bp=0x80;xp<xwidth;xp++) {
			color=(*(char *)field & bp) ? VIS_GC_FGCOLOR(vis) 
						    : VIS_GC_BGCOLOR(vis);
			ggiPutPixel(vis,x+xp,y,color);
      			if (!(bp>>=1)) {
				bp=0x80;
				field = ((uint8 *) field) + 1;
			}
    		}
	}

	return 0;
}

/**********TEMPORARY*******/
/* Put a character at x,y */
/**************************/
int GGIputc(ggi_visual *vis,int x,int y,char c)
{
	return GGIblit2c(vis,x,y,8,8,font+((unsigned char)c<<3));
}


/****TEMPORARY*******/
/* graphical printf */
/********************/
int GGIputs(ggi_visual *vis,int x,int y,const char *str)
{
	int rc=0;
	
	while(*str) {
		ggiPutc(vis,x,y,*str++);
		rc++;
		if ((x+=8)>=VIS_FB_WIDTH(vis)) {
			x=0;y+=8;
		}
	}

	return rc;
}

