/* 
   Graphics library for GGI. Pixels.

   Copyright (C) 1997 Jason McMullan - jmcc@cs.cmu.edu
   Copyright (C) 1995 Andreas Beck - becka@hp.rz.uni-duesseldorf.de

   If you do any modifications, I would like you to send diffs to me
   to allow for collecting a more and more complete set of drivers and
   to improve existing ones.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "ggi-dl.h"
#include "vga4.h"

/*******************************/
/* draw/get/put a single pixel */
/*******************************/

int GGIdrawpixel(ggi_visual *vis,int x,int y)
{
	volatile uchar *ptr; uchar foo;

	CHECKXY(vis,x,y);
 
	ptr=__localfb+((y*VIS_FB_WIDTH(vis)+x)>>3);
	ptr+=((VIS_GC_FGCOLOR(vis)&0xF) << 16);

	foo=*ptr;
	*ptr=0x80 >> (x&7);
	
	return EOK;
}

int GGIputpixel(ggi_visual *vis,int x,int y,ggi_uint col)
{ 
	volatile uchar *ptr; uchar foo;

	CHECKXY(vis,x,y);
 
	ptr=__localfb+((y*VIS_FB_WIDTH(vis)+x)>>3);
	ptr+=(col&0xF) << 16;

	foo=*ptr;
	*ptr=0x80 >> (x&7);
	
	return EOK;
}

int GGIgetpixel(ggi_visual *vis,int x,int y,ggi_uint *pixel)
{
	volatile uchar *ptr; ggi_uint i;

	CHECKXY(vis,x,y);

	ptr=(__localfb)+((y*VIS_FB_WIDTH(vis)+x)>>3);
	*pixel=0;
	for (i=0;i<4;i++) *pixel|=(ptr[i<<16]>>(~x&7)&1)<<i;

	return EOK;
}
