#include <stdio.h>
#include <stdlib.h>

#include "pointer.h"

typedef unsigned int u32;

void put_mask(const char *name,u32 *mask,int len)
{
  int i;
  
  printf("\nstatic unsigned int %s[POINTER_MASK_LEN] = {\n",name);
  for (i=0;i<(len-1);i++) 
	printf("\t0x%.8x,\n",mask[i]);
  printf("\t0x%.8x\n};\n",mask[i]);
}

int main(int argc,char **argv) 
{
   u32 *or_mask;
   u32 *xor_mask;
   u32 cx,co;
   int i,len,maxwidth,width,bit;
   const char *cp;

   for (len=0;pointer_map[len]!=NULL;len++);

   or_mask=(u32 *)malloc(sizeof(u32)*len);
   xor_mask=(u32 *)malloc(sizeof(u32)*len);

   maxwidth=0;
   for (i=0;i<len;i++) {
	cx=co=0;
	width=0;
	bit=0;
	for (cp=pointer_map[i];*cp!=0;cp++) {
	  switch (*cp) {
		case POINTER_MAP_CLEAR:
			co <<= 1;
			cx <<= 1;
			bit++;
			break;
		case POINTER_MAP_BLACK:
			co = (co << 1)|1;
			cx = (cx << 1)|1;
			bit++;
			width=bit;
			break;
		case POINTER_MAP_WHITE:
			co = (co << 1)|1;
			cx <<= 1;
			bit++;
			width=bit;
			break;
		case POINTER_MAP_REVERSE:
			co <<= 1;
			cx = (cx << 1)|1;
			bit++;
			width=bit;
			break;
		default:
			break;
	  }
	}
	or_mask[i] = (co << (32-width));
	xor_mask[i]= (cx << (32-width));
	if (width > maxwidth)
		maxwidth=width;
  }

  if (maxwidth>16 || len>16) {
    fprintf(stderr,"--WARNING: chipset/IBM/pointer.h uses a %dx%d pointer -"
                   " greater than 16x16 capability not tested\n",maxwidth,len);
  }

  printf("#ifndef _POINTER_MASK_H_\n"
         "#define _POINTER_MASK_H_\n\n"
         "/*\\ WARNING - this is automagically generated! \n"
         "|*| To modify, edit pointer.h, and re-run %s\n"
         "\\*/\n\n"
         "#define POINTER_MASK_LEN	%d\n"
         "#define POINTER_MASK_WIDTH	%d\n\n",
	 argv[0],len,maxwidth); 

  put_mask("pointer_or_mask",or_mask,len);
  put_mask("pointer_xor_mask",xor_mask,len);

  printf("\n#endif /* _POINTER_MASK_H_ */\n");

  return 0;
}

