/* NOTES:  You can make cursors up to 16x16,
 *         and any character that's not CLEAR, BLACK, or WHITE
 *         is consdered junk and ignored. You MUST end
 *         the bitmap with 'NULL'
 */

#define POINTER_MAP_CLEAR   '.'		/* Transparency  */
#define POINTER_MAP_BLACK   'b'		/* Always black  */
#define POINTER_MAP_WHITE   'o'		/* Always white  */
#define POINTER_MAP_REVERSE 'x'		/* Reverse pixel */

#undef  jsmARROW_POINTER
#define  jsmBULLSEYE_POINTER
#undef  mgXOR_POINTER
#undef  x11BIGARROW_POINTER
#undef x11HOTARROW_POINTER

/* 7x7 Arrow pointer
 * Contributor: Jason Scott Mcmullan
 */
#ifdef jsmARROW_POINTER
const char *pointer_map[] = 
{
	"b b b b b b b b",
	"b o o o o o b",
	"b o o o o b",
	"b o o o o o b",
	"b o b b o o o b",
	"b b . . b o b",
	"b . . . . b",
        NULL
};
#endif

/* 8x8 Bullseye pointer
 * Contributor: Jason Scott McMullan
 */
#ifdef jsmBULLSEYE_POINTER
const char *pointer_map[] = {
	". o o o o o o",
	"o o b b b b o o",
	"o b o o o o b o",
	"o b o . . o b o",
	"o b o . . o b o",
	"o b o o o o b o",
	"o o b b b b o o",
	". o o o o o o",
        NULL
};
#endif

/* 16x11 Xor-based pointer
 * Contributor: Massimiliano Ghilardi
 */
#ifdef mgXOR_POINTER
const char *pointer_map[] = {
 	"x",
 	"x x",
 	"x x x",
 	"x x x x",
 	"x x x x x",
 	"x x x x x x",
 	"x x x x x x x",
 	"x x x x x x x x",
 	"x x x x x x x x x",
 	"x x x x x x x x x x",
 	"x x x x x x x x x x x",
 	"x x x x x",
 	"x x x x",
 	"x x x",
 	"x x",
 	"x",
	NULL
};
#endif /* mgXOR_POINTER */

/* 10x16  Big arrow pointer
 * Contibutor: Jason McMullan
 * Source: /usr/include/X11/bitmaps/left_ptr{msk}
 */
#ifdef x11BIGARROW_POINTER 
const char *pointer_map[] =
{
	"b b",
	"b o b",
	"b o o b",
	"b o o o b",
	"b o o o o b",
	"b o o o o o b",
	"b o o o o o o b",
	"b o o o o o o o b",
	"b o o o o o o o o b",
	"b o o o o o b b b b",
	"b o o b o o b",
	"b o b . b o o b",
	"b b . . b o o b",
	". . . . . b o o b",
	". . . . . b o o b",
	". . . . . . b b",
        NULL
};
#endif

/* 10x16  Arrow pointer with `HotSpot'
 * Contibutor: Jason McMullan
 * Source: /usr/include/X11/bitmaps/left_ptr{msk}
 */
#ifdef x11HOTARROW_POINTER 
const char *pointer_map[] = {
	"b b",
	"b x b",
	"b x x b",
	"b x o o b",
	"b o o o o b",
	"b o o o o o b",
	"b o o o o o o b",
	"b o o o o o o o b",
	"b o o o o o o o o b",
	"b o o o o o b b b b",
	"b o o b o o b",
	"b o b . b o o b",
	"b b . . b o o b",
	". . . . . b o o b",
	". . . . . b o o b",
	". . . . . . b b",
        NULL
};
#endif
